/**
 * Autogenerated by Thrift Compiler (0.13.0)
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 *  @generated
 */
package org.eclipse.hawk.service.api;

@SuppressWarnings({"cast", "rawtypes", "serial", "unchecked", "unused"})
@javax.annotation.Generated(value = "Autogenerated by Thrift Compiler (0.13.0)", date = "2021-04-18")
public class HawkMetamodelNotFound extends org.apache.thrift.TException implements org.apache.thrift.TBase<HawkMetamodelNotFound, HawkMetamodelNotFound._Fields>, java.io.Serializable, Cloneable, Comparable<HawkMetamodelNotFound> {
  private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("HawkMetamodelNotFound");

  private static final org.apache.thrift.protocol.TField METAMODEL_URI_FIELD_DESC = new org.apache.thrift.protocol.TField("metamodelURI", org.apache.thrift.protocol.TType.STRING, (short)1);

  private static final org.apache.thrift.scheme.SchemeFactory STANDARD_SCHEME_FACTORY = new HawkMetamodelNotFoundStandardSchemeFactory();
  private static final org.apache.thrift.scheme.SchemeFactory TUPLE_SCHEME_FACTORY = new HawkMetamodelNotFoundTupleSchemeFactory();

  public @org.apache.thrift.annotation.Nullable java.lang.String metamodelURI; // optional

  /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
  public enum _Fields implements org.apache.thrift.TFieldIdEnum {
    METAMODEL_URI((short)1, "metamodelURI");

    private static final java.util.Map<java.lang.String, _Fields> byName = new java.util.HashMap<java.lang.String, _Fields>();

    static {
      for (_Fields field : java.util.EnumSet.allOf(_Fields.class)) {
        byName.put(field.getFieldName(), field);
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, or null if its not found.
     */
    @org.apache.thrift.annotation.Nullable
    public static _Fields findByThriftId(int fieldId) {
      switch(fieldId) {
        case 1: // METAMODEL_URI
          return METAMODEL_URI;
        default:
          return null;
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, throwing an exception
     * if it is not found.
     */
    public static _Fields findByThriftIdOrThrow(int fieldId) {
      _Fields fields = findByThriftId(fieldId);
      if (fields == null) throw new java.lang.IllegalArgumentException("Field " + fieldId + " doesn't exist!");
      return fields;
    }

    /**
     * Find the _Fields constant that matches name, or null if its not found.
     */
    @org.apache.thrift.annotation.Nullable
    public static _Fields findByName(java.lang.String name) {
      return byName.get(name);
    }

    private final short _thriftId;
    private final java.lang.String _fieldName;

    _Fields(short thriftId, java.lang.String fieldName) {
      _thriftId = thriftId;
      _fieldName = fieldName;
    }

    public short getThriftFieldId() {
      return _thriftId;
    }

    public java.lang.String getFieldName() {
      return _fieldName;
    }
  }

  // isset id assignments
  private static final _Fields optionals[] = {_Fields.METAMODEL_URI};
  public static final java.util.Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
  static {
    java.util.Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new java.util.EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
    tmpMap.put(_Fields.METAMODEL_URI, new org.apache.thrift.meta_data.FieldMetaData("metamodelURI", org.apache.thrift.TFieldRequirementType.OPTIONAL, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.STRING)));
    metaDataMap = java.util.Collections.unmodifiableMap(tmpMap);
    org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(HawkMetamodelNotFound.class, metaDataMap);
  }

  public HawkMetamodelNotFound() {
  }

  /**
   * Performs a deep copy on <i>other</i>.
   */
  public HawkMetamodelNotFound(HawkMetamodelNotFound other) {
    if (other.isSetMetamodelURI()) {
      this.metamodelURI = other.metamodelURI;
    }
  }

  public HawkMetamodelNotFound deepCopy() {
    return new HawkMetamodelNotFound(this);
  }

  @Override
  public void clear() {
    this.metamodelURI = null;
  }

  @org.apache.thrift.annotation.Nullable
  public java.lang.String getMetamodelURI() {
    return this.metamodelURI;
  }

  public HawkMetamodelNotFound setMetamodelURI(@org.apache.thrift.annotation.Nullable java.lang.String metamodelURI) {
    this.metamodelURI = metamodelURI;
    return this;
  }

  public void unsetMetamodelURI() {
    this.metamodelURI = null;
  }

  /** Returns true if field metamodelURI is set (has been assigned a value) and false otherwise */
  public boolean isSetMetamodelURI() {
    return this.metamodelURI != null;
  }

  public void setMetamodelURIIsSet(boolean value) {
    if (!value) {
      this.metamodelURI = null;
    }
  }

  public void setFieldValue(_Fields field, @org.apache.thrift.annotation.Nullable java.lang.Object value) {
    switch (field) {
    case METAMODEL_URI:
      if (value == null) {
        unsetMetamodelURI();
      } else {
        setMetamodelURI((java.lang.String)value);
      }
      break;

    }
  }

  @org.apache.thrift.annotation.Nullable
  public java.lang.Object getFieldValue(_Fields field) {
    switch (field) {
    case METAMODEL_URI:
      return getMetamodelURI();

    }
    throw new java.lang.IllegalStateException();
  }

  /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
  public boolean isSet(_Fields field) {
    if (field == null) {
      throw new java.lang.IllegalArgumentException();
    }

    switch (field) {
    case METAMODEL_URI:
      return isSetMetamodelURI();
    }
    throw new java.lang.IllegalStateException();
  }

  @Override
  public boolean equals(java.lang.Object that) {
    if (that == null)
      return false;
    if (that instanceof HawkMetamodelNotFound)
      return this.equals((HawkMetamodelNotFound)that);
    return false;
  }

  public boolean equals(HawkMetamodelNotFound that) {
    if (that == null)
      return false;
    if (this == that)
      return true;

    boolean this_present_metamodelURI = true && this.isSetMetamodelURI();
    boolean that_present_metamodelURI = true && that.isSetMetamodelURI();
    if (this_present_metamodelURI || that_present_metamodelURI) {
      if (!(this_present_metamodelURI && that_present_metamodelURI))
        return false;
      if (!this.metamodelURI.equals(that.metamodelURI))
        return false;
    }

    return true;
  }

  @Override
  public int hashCode() {
    int hashCode = 1;

    hashCode = hashCode * 8191 + ((isSetMetamodelURI()) ? 131071 : 524287);
    if (isSetMetamodelURI())
      hashCode = hashCode * 8191 + metamodelURI.hashCode();

    return hashCode;
  }

  @Override
  public int compareTo(HawkMetamodelNotFound other) {
    if (!getClass().equals(other.getClass())) {
      return getClass().getName().compareTo(other.getClass().getName());
    }

    int lastComparison = 0;

    lastComparison = java.lang.Boolean.valueOf(isSetMetamodelURI()).compareTo(other.isSetMetamodelURI());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetMetamodelURI()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.metamodelURI, other.metamodelURI);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    return 0;
  }

  @org.apache.thrift.annotation.Nullable
  public _Fields fieldForId(int fieldId) {
    return _Fields.findByThriftId(fieldId);
  }

  public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
    scheme(iprot).read(iprot, this);
  }

  public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
    scheme(oprot).write(oprot, this);
  }

  @Override
  public java.lang.String toString() {
    java.lang.StringBuilder sb = new java.lang.StringBuilder("HawkMetamodelNotFound(");
    boolean first = true;

    if (isSetMetamodelURI()) {
      sb.append("metamodelURI:");
      if (this.metamodelURI == null) {
        sb.append("null");
      } else {
        sb.append(this.metamodelURI);
      }
      first = false;
    }
    sb.append(")");
    return sb.toString();
  }

  public void validate() throws org.apache.thrift.TException {
    // check for required fields
    // check for sub-struct validity
  }

  private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
    try {
      write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
    } catch (org.apache.thrift.TException te) {
      throw new java.io.IOException(te);
    }
  }

  private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, java.lang.ClassNotFoundException {
    try {
      read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
    } catch (org.apache.thrift.TException te) {
      throw new java.io.IOException(te);
    }
  }

  private static class HawkMetamodelNotFoundStandardSchemeFactory implements org.apache.thrift.scheme.SchemeFactory {
    public HawkMetamodelNotFoundStandardScheme getScheme() {
      return new HawkMetamodelNotFoundStandardScheme();
    }
  }

  private static class HawkMetamodelNotFoundStandardScheme extends org.apache.thrift.scheme.StandardScheme<HawkMetamodelNotFound> {

    public void read(org.apache.thrift.protocol.TProtocol iprot, HawkMetamodelNotFound struct) throws org.apache.thrift.TException {
      org.apache.thrift.protocol.TField schemeField;
      iprot.readStructBegin();
      while (true)
      {
        schemeField = iprot.readFieldBegin();
        if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
          break;
        }
        switch (schemeField.id) {
          case 1: // METAMODEL_URI
            if (schemeField.type == org.apache.thrift.protocol.TType.STRING) {
              struct.metamodelURI = iprot.readString();
              struct.setMetamodelURIIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          default:
            org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();

      // check for required fields of primitive type, which can't be checked in the validate method
      struct.validate();
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot, HawkMetamodelNotFound struct) throws org.apache.thrift.TException {
      struct.validate();

      oprot.writeStructBegin(STRUCT_DESC);
      if (struct.metamodelURI != null) {
        if (struct.isSetMetamodelURI()) {
          oprot.writeFieldBegin(METAMODEL_URI_FIELD_DESC);
          oprot.writeString(struct.metamodelURI);
          oprot.writeFieldEnd();
        }
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

  }

  private static class HawkMetamodelNotFoundTupleSchemeFactory implements org.apache.thrift.scheme.SchemeFactory {
    public HawkMetamodelNotFoundTupleScheme getScheme() {
      return new HawkMetamodelNotFoundTupleScheme();
    }
  }

  private static class HawkMetamodelNotFoundTupleScheme extends org.apache.thrift.scheme.TupleScheme<HawkMetamodelNotFound> {

    @Override
    public void write(org.apache.thrift.protocol.TProtocol prot, HawkMetamodelNotFound struct) throws org.apache.thrift.TException {
      org.apache.thrift.protocol.TTupleProtocol oprot = (org.apache.thrift.protocol.TTupleProtocol) prot;
      java.util.BitSet optionals = new java.util.BitSet();
      if (struct.isSetMetamodelURI()) {
        optionals.set(0);
      }
      oprot.writeBitSet(optionals, 1);
      if (struct.isSetMetamodelURI()) {
        oprot.writeString(struct.metamodelURI);
      }
    }

    @Override
    public void read(org.apache.thrift.protocol.TProtocol prot, HawkMetamodelNotFound struct) throws org.apache.thrift.TException {
      org.apache.thrift.protocol.TTupleProtocol iprot = (org.apache.thrift.protocol.TTupleProtocol) prot;
      java.util.BitSet incoming = iprot.readBitSet(1);
      if (incoming.get(0)) {
        struct.metamodelURI = iprot.readString();
        struct.setMetamodelURIIsSet(true);
      }
    }
  }

  private static <S extends org.apache.thrift.scheme.IScheme> S scheme(org.apache.thrift.protocol.TProtocol proto) {
    return (org.apache.thrift.scheme.StandardScheme.class.equals(proto.getScheme()) ? STANDARD_SCHEME_FACTORY : TUPLE_SCHEME_FACTORY).getScheme();
  }
}

